﻿package com.hydrotik.utils {
	
	/**
	 * @author Donovan Adams
	 * @version March 3, 2007
	 * @usage Example:<code></code>
	 * @description XML Manager
	 * @history
	 * @sends
	 * @todo 
	 * 
	 */
	 
    import flash.display.Sprite;
    import flash.events.*;
    import flash.net.*;
	
    public class XMLManager extends Sprite {
		
		private var loader:URLLoader;
		private var _oListener:Object;
		public var xml:XML;

        public function XMLManager(path:String) {

            loader = new URLLoader();
            configureListeners(loader);

            var request:URLRequest = new URLRequest(path);
            try {
                loader.load(request);
            } catch (error:Error) {
                trace("Unable to load requested document.");
            }
        }

        private function configureListeners(dispatcher:IEventDispatcher):void {
            dispatcher.addEventListener(Event.COMPLETE, completeHandler);
            dispatcher.addEventListener(ProgressEvent.PROGRESS, progressHandler);
            dispatcher.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
        }

        private function completeHandler(event:Event):void {
			xml = new XML(event.target.data);
			dispatchEvent(new Event("evtXMLLoaded", {stuff: "event complete!"}));
        }


        private function progressHandler(event:ProgressEvent):void {
			dispatchEvent(new Event("evtXMLProgress", {stuff: "event loading!"}));
        }

        private function ioErrorHandler(event:IOErrorEvent):void {
            trace("ioErrorHandler: " + event);
        }
    }
	
	
}